def addthree(x):
  return x + 3

def clearRed(pic):
 for p in getPixels(pic):
   redvalue = 0
   setRed(p, redvalue)

def grayscale(pic): 
 for p in getPixels(pic):
   redvalue = getRed(p)
   greenvalue = getGreen(p)
   bluevalue = getBlue(p)

   grayvalue = (redvalue + greenvalue + bluevalue) / 3
   setRed(p, grayvalue)
   setGreen(p, grayvalue)
   setBlue(p, grayvalue)

# if red is too high, make it 0.
def flopRed(pic):
  for p in getPixels(pic):
    r = getRed(p)

    if(r > 100):
     setRed(p, 0)

def flopBlue(pic):
 for p in getPixels(pic):
   b = getBlue(p)

   if(b > 100):
     setBlue(p, 0)

def flopGreen(pic):
 for p in getPixels(pic):
   g = getGreen(p)

   if(g > 100):
     setGreen(p, 0)

def negative(pic):
  for p in getPixels(pic):
   redvalue = getRed(p)
   greenvalue = getGreen(p)
   bluevalue = getBlue(p)
   
   newredvalue = 255 - redvalue
   newgreenvalue = 255 - greenvalue
   newbluevalue = 255 - greenvalue

   setRed(p, newredvalue)
   setGreen(p, newgreenvalue)
   setBlue(p, newbluevalue)
   
def forloopexample(thelist):
 total = 0
 for thing in thelist:
  total = total + thing
 print total  

def copyPicture2(sourcePic,canvas,startX, startY):
# Input parameters are source picture, target picture
# target (X,Y) pixel location
  # Now do the actual copying
  targetX = startX
  for sourceX in range (1, getWidth(sourcePic)):
    targetY=startY
    for sourceY in range (1,getHeight(sourcePic)):
      color = getColor(getPixel(sourcePic,sourceX,sourceY))
      
      if(not distance(color,white) == 0):
       setColor(getPixel(canvas,targetX,targetY),color)
      targetY=targetY + 1
    targetX= targetX+1
  show(sourcePic)
  show(canvas)
  return canvas

def collage(picture,canvas):
  print picture
  print canvas
  middleX = getWidth(canvas)/2
  middleY = getHeight(canvas)/2
  targetX = middleX - (getWidth(picture)*2)
  targetY = middleY - getHeight(picture)
  # Check placement values
  print middleX
  print middleY
  print targetX, targetY
  copyPicture2(picture,canvas,targetX, targetY)
  increaseRed2(picture)
  targetX = middleX - getWidth(picture)
  copyPicture2(picture,canvas,targetX,targetY)
  decreaseGreen(picture)
  targetX = middleX
  copyPicture2(picture,canvas,targetX,targetY)
  decreaseBlue(picture)
  targetX = middleX + getWidth(picture)
  copyPicture2(picture,canvas,targetX,targetY)
  return canvas

def horizontalMirror(canvas):
  #Now, pick the point the picture will be mirrored across
  #this function will mirror horizontally, so divide the height by 2
  mirrorPoint=getHeight(canvas)/2
  #make a loop to go row by row, through the bottom half of the picture
  for y in range(1, mirrorPoint):
    #make another loop that goes through each pixel on each row
    for x in range(1, getWidth(canvas)):
      #First we find where we want to mirror to
      mirrorTo=getPixel(canvas, x, y+mirrorPoint)
      #Then we find where we want to get the image from that we are mirroring
      mirrorFrom=getPixel(canvas,x,mirrorPoint-y)
      #Finally, we set the color in the pixel that we want to hold the mirror image
      setColor(mirrorTo, getColor(mirrorFrom))

def chromakey(source,bg):
  # source should have something in front of green, bg is new background
  for x in range(1,getWidth(source)):
    for y in range(1,getHeight(source)):

      if (x < getWidth(bg) and y < getHeight(bg) ):
        p=getPixel(source,x,y)
        # My definition of green: if red+blue < green
        if (getRed(p) + getBlue(p) < getGreen(p)):
        #Then grab the color at same spot from new background
          setColor(p,getColor(getPixel(bg,x,y)))
  return source

def spincolors(pic):
 for p in getPixels(pic):
  r = getRed(p)
  g = getGreen(p)
  b = getBlue(p)
  
  setRed(p,g)
  setGreen(p,b)
  setBlue(p,r)

def mirrorVertical(source):
  mirrorpoint = int(getWidth(source)/2)
  for y in range(1,getHeight(source)):
    for x in range(1,mirrorpoint):

      leftside = mirrorpoint - x
      rightside = mirrorpoint + x

      target = getPixel(source, rightside ,y)
      sourcepixel = getPixel(source, leftside ,y)
      c = getColor(sourcepixel)
      setColor(target,c)

def mirrorVertical2(source):
  mirrorpoint = int(getWidth(source)/2)
  for y in range(1,getHeight(source)):
    for x in range(1,mirrorpoint):

      leftside = mirrorpoint - x
      rightside = mirrorpoint + x

      target = getPixel(source, leftside ,y)
      sourcepixel = getPixel(source, rightside ,y)
      c = getColor(sourcepixel)
      setColor(target,c)

import random
def static(pic):
 i = 0
 for p in getPixels(pic):
   redvalue = getRed(p)
   greenvalue = getGreen(p)
   bluevalue = getBlue(p)

   rand = random.random() * 255
   if( random.random() > 0.8):
       setRed(p, rand)
       setGreen(p, rand)
       setBlue(p, rand)
  
  
   i = i + 1
  


def everyothertime():
  numbers = [100, 40, 8, 900, 20]
  i = 0
  for num in numbers:
    if((i % 3) == 1):
      print num, i
    i = i + 1


  